﻿using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Threading;
using UnityEngine;

public class ProgressTexture : MonoBehaviour
{
    public int width = 32;
    public int height = 32;


    public Texture2D genTexture;
    public Texture2D colorTexture;

    private int colorW;
    private int colorH;

    public Transform fog;
    public Material mat;

    public Transform role;
    public Transform dimian;
    public float radius;

    float dimianW;
    float dimianH;
    float roleX;
    float roleY;
    private Color32[] colors;
    private Color32[] rcolors;

    Thread t;
    // Start is called before the first frame update
    void Start()
    {
        rcolors = colorTexture.GetPixels32();
        
        colorW = colorTexture.width;
        colorH = colorTexture.height;

        dimianW = dimian.position.x * 2;
        dimianH = dimian.position.z * 2;
        roleX = role.position.x;
        roleY = role.position.z;
        mat = fog.GetComponent<MeshRenderer>().material;
        genTexture = new Texture2D(width, height);
        colors = new Color32[width * height];


        mat.SetTexture("_VisibleTex", genTexture);

        //计算颜色
        t = new Thread( new ThreadStart(this.ThreadJob));
        t.IsBackground = true;
        t.Start();
    }

    private void OnDestroy()
    {
        t.Abort();
    }


    void ThreadJob()
    {
        while(true)
        {
            DrawTexture();
            Thread.Sleep(1 / 60);
        }

    }
    void Update()
    {
        roleX = role.position.x;
        roleY = role.position.z;
      
        genTexture.SetPixels32(colors);
        //如何不会用到mipMap 使用genTexture.Apply(false)会节省很多消耗
        genTexture.Apply();
    }

    void DrawTexture()
    {
        //图像以位置坐标是反向的 所以需要1-
        int XEnd = (int)((1 - ((roleY - radius) / dimianH)) * width);
        XEnd = Mathf.Min(XEnd, width);
        int XStart = (int)((1 - (roleY + radius) / dimianH) * width);
        XStart = Mathf.Max(XStart, 0);
        int YEnd = (int)((1 - (roleX - radius) / dimianW) * height);
        YEnd = Mathf.Min(YEnd, height);
        int YStart = (int)((1 - (roleX + radius) / dimianW) * height);
        YStart = Mathf.Max(YStart, 0);

        int h = XEnd - XStart;
        int w = YEnd - YStart;
        for (int i = XStart; i < XEnd; ++i)
        {
            for(int j = YStart; j < YEnd; ++j)
            {
                int index = i * width + j;
                float a = (float)(i - XStart) / h;
                float b = (float)(j - YStart) / w;
                int col = (int)(a * colorW);
                int row = (int)(b * colorH);
                int index2 = (int)(Mathf.Max(row,0 )* colorW + Mathf.Max(col,0));
                if(colors[index].r < rcolors[index2].r)
                {
                    colors[index].r = rcolors[index2].r;
                }
                
            }
        }
        
    }
}
